import VirtualHostFolder, Host, Alias, Redirect
import ZPublisher.HTTPRequest

def initialize(context):

    context.registerClass(
        VirtualHostFolder.VirtualHostFolder,
        constructors=(VirtualHostFolder.manage_addVirtualHostFolderForm,
                      VirtualHostFolder.manage_addVirtualHostFolder),
        icon='www/VHFolder_icon.gif'
        )

    context.registerClass(
        Host.Host,
        constructors=(Host.manage_addHostForm,
                      Host.manage_addHost),
        visibility=None,
        icon='www/host_icon.gif'
        )

    context.registerClass(
        Alias.Alias,
        constructors=(Alias.manage_addAliasForm,
                      Alias.manage_addAlias),
        visibility=None,
        icon='www/alias_icon.gif'
        )

    context.registerClass(
        Redirect.Redirect,
        constructors=(Redirect.manage_addRedirectForm,
                      Redirect.manage_addRedirect),
        visibility=None,
        icon='www/redirect_icon.gif'
        )
    
    context.registerHelp()
    context.registerHelpTitle('Virtual Host Folder')

def setAliasFolder(self, aliasName):
    """ Clean the request to hide an alias object forced in the path """
    _steps=self._steps
    _steps.pop()
    _steps[-1]=aliasName
    self.steps.pop()
    self._resetURLS()

def setAliasName(self, aliasName):
    "Does the rest of the job (not a lot)"
    self.steps[-1]=aliasName

# monkey-fixes; these are not overriding anything, but new functions
ZPublisher.HTTPRequest.HTTPRequest.setAliasFolder=setAliasFolder
ZPublisher.HTTPRequest.HTTPRequest.setAliasName=setAliasName
